//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     LimeGreen
#property indicator_color2     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_level1     0

//
//
//
//
//

extern double BoxPeriod   = 15;
extern bool   JustLastBar = true;

//
//
//
//
//

double Hi[];
double Lo[];
double no[];
double kr[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------

int init()
{
   IndicatorDigits(0);      
   IndicatorBuffers(4);   
      SetIndexBuffer(0,kr); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,no); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,Hi);
      SetIndexBuffer(3,Lo);
   SetIndexEmptyValue(0,0.00);
   SetIndexEmptyValue(1,0.00);
   SetIndexEmptyValue(2,0.00);
   SetIndexEmptyValue(3,0.00);
   SetIndexLabel(0,"XO Up");
   SetIndexLabel(1,"XO Down");

   //
   //
   //
   //
   //
      
   IndicatorShortName("XO ("+DoubleToStr(BoxPeriod,2)+")");
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {         
      if (i>=(Bars-2)) { Hi[i+1]=Close[i]; Lo[i+1]=Close[i]; continue; }
         double cur   = Close[i];
                Hi[i] = Hi[i+1];
                Lo[i] = Lo[i+1];
                no[i] = no[i+1];
                kr[i] = kr[i+1];

                if (cur > (Hi[i]+BoxPeriod*Point)) 
                {
                     Hi[i] = cur;
                     Lo[i] = cur-BoxPeriod*Point;
                     kr[i] = kr[i+1]+1;
                     no[i] = 0;
                }
                if (cur < (Lo[i]-BoxPeriod*Point)) 
                {
                     Lo[i] = cur;
                     Hi[i] = cur+BoxPeriod*Point;
                     no[i] = no[i+1]-1;
                     kr[i] = 0;
                }
   }
   return(0);
}

